﻿#ifndef LIB_SPLIT_H
#define LIB_SPLIT_H
/*
    This header file is part of CadCam.

    This header file is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This header file is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CadCam.  If not, see <https://www.gnu.org/licenses/>.

    AUTOR     : Grotius
    DATE      : 24.6.2020
    REVISION  : --
    TODO      : --
    USAGE     : --
    PROTOCOL  : --
    NOTES     : --
*/
#include <iostream>
#include <algorithm>
#include <math.h>
#include <structs.h>
#include <variable.h>
#include <vector>
#include <iterator>
void sort_intersectons_line(std::vector<OBJECT>::iterator it);
void sort_intersectons_arc(std::vector<OBJECT>::iterator it);
bool contains_point(std::vector<POINT> container, std::vector<POINT>::iterator it);

std::vector<OBJECT> split_primitives(std::vector<OBJECT>array){

    std::vector<OBJECT> output_array;
    std::vector<OBJECT>::iterator it;
    std::vector<POINT>::iterator it1;

    //auto construct_objects =[](std::vector<OBJECT>::iterator it){
    //return array;
    //};

    for(it=array.begin(); it<array.end(); it++){

        if(it->type=="line"){

            sort_intersectons_line(it);

            OBJECT obj;
            obj=*it; //take all parameters of orginal
            obj.start.x=it->start.x;
            obj.start.y=it->start.y;
            obj.start.z=it->start.z;

            for(it1=it->intersect.begin(); it1<it->intersect.end(); it1++){
                std::cout<<"line intersections x :"<<it1->x<<" y: "<<it1->y<<std::endl;
                obj.end.x=it1->x;
                obj.end.y=it1->y;
                obj.end.z=it1->z;
                output_array.push_back(obj);
                obj.start.x=it1->x;
                obj.start.y=it1->y;
                obj.start.z=it1->z;
            }

            obj.end.x=it->end.x;
            obj.end.y=it->end.y;
            obj.end.z=it->end.z;
            obj.deg_angle_end=it->deg_angle_end;
            output_array.push_back(obj);

            //output_array.insert(output_array.end(), to_output_array.begin(), to_output_array.end());

        }
        if(it->type=="arc"){
            sort_intersectons_arc(it);

            OBJECT obj;
            obj=*it; //take all parameters of orginal
            obj.type="arc";
            obj.start.x=it->start.x;
            obj.start.y=it->start.y;
            obj.start.z=it->start.z;

            std::cout<<"arc start, x: "<<obj.start.x<<" y: "<<obj.start.y<<std::endl;

            for(it1=it->intersect.begin(); it1<it->intersect.end(); it1++){
                obj.end.x=it1->x;
                obj.end.y=it1->y;
                obj.end.z=it1->z;
                std::cout<<"arc intersect end, x: "<<obj.end.x<<" y: "<<obj.end.y<<std::endl;

                if(it->d>0){ //G2
                    obj.deg_angle_start = 180/M_PI*atan2(obj.end.y-obj.center.y, obj.end.x-obj.center.x);
                    obj.deg_angle_end = 180/M_PI*atan2(obj.start.y-obj.center.y, obj.start.x-obj.center.x);
                }
                if(it->d<0){ //G3
                    obj.deg_angle_start = 180/M_PI*atan2(obj.start.y-obj.center.y, obj.start.x-obj.center.x);
                    obj.deg_angle_end =  180/M_PI*atan2(obj.end.y-obj.center.y, obj.end.x-obj.center.x);
                }

                output_array.push_back(obj);
                obj.start.x=it1->x;
                obj.start.y=it1->y;
                obj.start.z=it1->z;
                std::cout<<"arc intersect start, x: "<<obj.start.x<<" y: "<<obj.start.y<<std::endl;
            }
            obj.end.x=it->end.x;
            obj.end.y=it->end.y;
            obj.end.z=it->end.z;
            std::cout<<"arc end, x: "<<obj.end.x<<" y: "<<obj.end.y<<std::endl;

            if(it->d>0){ //G2
                obj.deg_angle_start = 180/M_PI*atan2(obj.end.y-obj.center.y, obj.end.x-obj.center.x);
                obj.deg_angle_end = 180/M_PI*atan2(obj.start.y-obj.center.y, obj.start.x-obj.center.x);
            }
            if(it->d<0){ //G3
                obj.deg_angle_start = 180/M_PI*atan2(obj.start.y-obj.center.y, obj.start.x-obj.center.x);
                obj.deg_angle_end =  180/M_PI*atan2(obj.end.y-obj.center.y, obj.end.x-obj.center.x);
            }

            output_array.push_back(obj);
        }
        //obj=*it;
        //output_array.push_back(obj);
    }


    //make a list of unique intersections. this is a preprocess for lib_pocket.h
    std::vector<POINT> unique_intersections;
    //collect unique intersection numbers.
    for(it=output_array.begin(); it<output_array.end(); it++){
        for(it1=it->intersect.begin(); it1<it->intersect.end(); it1++){

            bool contains=contains_point(unique_intersections,it1);
            if(contains){
                //do nothing, point is already stored
                //std::cout<<"duplicate x: "<<it1->x<<" y: "<<it1->y<<std::endl;
            }
            if(!contains){
                //save point
                unique_intersections.push_back(*it1);
                //std::cout<<"unique intersection saved x: "<<it1->x<<" y: "<<it1->y<<std::endl;
            }
        }
    }

    //attach the unique intersections to object endpoints. Compare wich endpoint is equal to a unique intersection and save this in the object.end_intersect parameter
    for(it=output_array.begin(); it<output_array.end(); it++){
        it->sector=0; //set at 0 here, not initialized in the struct as 0
        for(unsigned int i=0; i<unique_intersections.size(); i++){

            if(it->end.x<unique_intersections.at(i).x+0.01 && it->end.x>unique_intersections.at(i).x-0.01 &&   it->end.y<unique_intersections.at(i).y+0.01 && it->end.y>unique_intersections.at(i).y-0.01 ){
                it->end_intersection=int(i);
                //std::cout<<"object nr: "<<it-output_array.begin() <<"end intersection nr: "<<it1-unique_intersections.begin()<<std::endl;
            }
        }
    }

    //print result
    int no=0;
    for(it=output_array.begin(); it<output_array.end(); it++){
        //std::cout<<"object nr: "<<no<<"end intersection nr: "<<it->end_intersection<<std::endl;
        //std::cout<<"x start: "<<it->start.x<<"y start: "<<it->start.y<<std::endl;
        //std::cout<<"x end: "<<it->end.x<<"y end: "<<it->end.y<<std::endl;
        no++;
    }

    return output_array;
}

bool contains_point(std::vector<POINT> container, std::vector<POINT>::iterator it){
    std::vector<POINT>::iterator it1;
    for(it1=container.begin(); it1<container.end(); it1++){
        if(it->x>it1->x-0.01 && it->x<it1->x+0.01 && it->y>it1->y-0.01 && it->y<it1->y+0.01 ){
            return true;
        }
    }
    return false;
}


void sort_intersectons_arc(std::vector<OBJECT>::iterator it){

    /*//test output
    int option=4;
    OBJECT object;
    object.type="arc";
    object.red=255; object.alpha=255;

    if(option==1){ //tested ok
        object.deg_angle_start=0;
        object.deg_angle_end=180;
        object.center.x=0;
        object.center.y=0;
        object.intersect.push_back({0,100,0});
        object.intersect.push_back({-50,50,0});
        object.intersect.push_back({50,50,0});
    }
    if(option==2){ //tested ok
        object.deg_angle_start=270;
        object.deg_angle_end=90;
        object.center.x=0;
        object.center.y=0;
        object.intersect.push_back({100,90,0});
        object.intersect.push_back({100,50,0});
        object.intersect.push_back({100,25,0});
    }
    if(option==3){ //tested ok
        object.deg_angle_start=270;
        object.deg_angle_end=90;
        object.center.x=0;
        object.center.y=0;
        object.intersect.push_back({100,-25,0});
        object.intersect.push_back({100,-50,0});
        object.intersect.push_back({100,-80,0});
    }

    if(option==4){ //mixed values, tested ok
        object.deg_angle_start=10;
        object.deg_angle_end=370;
        object.center.x=0;
        object.center.y=0;
        object.intersect.push_back({-100,0,0});
        object.intersect.push_back({-100,100,0});
        object.intersect.push_back({0,100,0});
        object.intersect.push_back({100,100,0});
        object.intersect.push_back({100,-100,0});
        object.intersect.push_back({-100,-100,0});
    }
    cad.push_back(object);

    std::vector<OBJECT>::iterator it;
    it=cad.begin();*/

    std::vector<POINT>::iterator it1;
    std::vector<double> angles;
    struct IP{
        POINT p;
        double deg_angle;
        double arc_angle_from_start;
    };
    IP ip; //intersection point
    std::vector<IP> intersection_point; //intersection points
    std::vector<IP>::iterator it2;


    auto sort_by_arc_angle_from_start=[](const IP & lhs, const IP & rhs){ //function inside a function, works oke
        return lhs.arc_angle_from_start > rhs.arc_angle_from_start;
    };


    if(it->type=="arc"){

        //arc angles startpoint, endpoint
        double deg_angle_start=it->deg_angle_start;
        double deg_angle_end=it->deg_angle_end;
        if(deg_angle_start<0){deg_angle_start=360-(deg_angle_start*-1);}
        if(deg_angle_end<0){deg_angle_end=360-(deg_angle_end*-1);}

        //write intersection point angles to container
        for(it1=it->intersect.begin(); it1<it->intersect.end(); it1++){
            double pi_angle_p=atan2(it1->y-it->center.y,it1->x-it->center.x);
            double deg_angle_p=(180/M_PI)*pi_angle_p;
            //Angles defined from 0 to 360 degrees. if angle<0, make them positive
            if(deg_angle_p<0){deg_angle_p=360-(deg_angle_p*-1);}

            //write all intersection angles data to container to be processed later on
            ip.p={it1->x,it1->y,it1->z};
            ip.deg_angle=deg_angle_p;
            intersection_point.push_back(ip);
        }

        //point by point we calculate the arc angle seen from the arc start, there are 3 different solutions, this makes it more complicated
        for(it2=intersection_point.begin(); it2<intersection_point.end(); it2++){
            /*option 1
                                          |90
                                          |  *point
                                          |
                                *end      |         *start
                                __________|__________ 0
                               180        |           360
                                          |
                                          |
                                          |270               */

            if(deg_angle_start<deg_angle_end){
                if(it2->deg_angle>deg_angle_start && it2->deg_angle<deg_angle_end){
                    it2->arc_angle_from_start=it2->deg_angle-deg_angle_start;
                }
            }

            /*option 2
                                          |90
                                          |       *end
                                          |
                                          |         *point
                                __________|__________ 0
                               180        |           360
                                          |
                                          |       *start
                                          |270               */

            if(deg_angle_start>deg_angle_end){
                if(it2->deg_angle<deg_angle_start&& it2->deg_angle<deg_angle_end){
                    it2->arc_angle_from_start=(360-deg_angle_start)+it2->deg_angle;
                }
            }

            /*option 3
                                          |90
                                          |       *end
                                          |
                                          |
                                __________|__________ 0
                               180        |           360
                                          |        *point
                                          |       *start
                                          |270               */

            if(deg_angle_start>deg_angle_end){
                if(it2->deg_angle>deg_angle_start && it2->deg_angle>deg_angle_end ){
                    it2->arc_angle_from_start=it2->deg_angle-deg_angle_start;
                }
            }
        }

        //sort angles from startangle to endangle
        std::sort(intersection_point.begin(), intersection_point.end(), sort_by_arc_angle_from_start);



        //print result
        /*for(it2=ips.begin(); it2<ips.end(); it2++){
            std::cout<<"point 1, x: "<<it2->p.x<<" y: "<<it2->p.y<<std::endl;
        }*/

        //erase all unsorted intersections of it.
        it->intersect.clear();

        //fill it with sorted intersections.
        for(it2=intersection_point.begin(); it2<intersection_point.end(); it2++){
            //std::cout<<"point 1, x: "<<it2->p.x<<" y: "<<it2->p.y<<std::endl;

            it->intersect.push_back(it2->p);
            it->intersect_deg_angle.push_back(it2->deg_angle);
        }
    }
}

void sort_intersectons_line(std::vector<OBJECT>::iterator it){
    std::vector<POINT>::iterator it1;
    std::vector<std::vector<double>> points;
    std::vector<POINT> pc;

    double x=0;
    double y=0;
    double xi=0;
    double yi=0;
    double dist=0;

    x=it->start.x; //we sort seen from startpoint.
    y=it->start.y;

    //bring all unsorted intersection points into a 2d vector container with distance from starpoint.
    for(it1=it->intersect.begin(); it1<it->intersect.end(); it1++){
        xi=it1->x;
        yi=it1->y;
        dist=sqrt(pow(x-xi,2)+pow(y-yi,2));

        std::vector<double> pa;
        pa.push_back(dist);
        pa.push_back(xi);
        pa.push_back(yi);
        points.push_back(pa);
    }

    //sort the first column of the container, sort the distance from startpoint.
    std::sort(points.begin(),points.end());

    //bring back datatype to POINT
    POINT pb;
    for(unsigned int i=0; i<points.size(); i++){
        pb.x=points[i][1];
        pb.y=points[i][2];
        pc.push_back(pb);
    }

    //erase all unsorted intersetions of it.
    it->intersect.clear();

    //fill it with sorted intersections.
    it->intersect=pc;
    pc.clear();
}

#endif // LIB_SPLIT_H























